const BizResult = require("./BizResult");
const BizResultCode = require("./BaseResultCode");
const logger = require("./logger")("FileController.js");
// const publish_proto = require("./grpc/publish");
const grpc = require("@grpc/grpc-js");
const config = require("config");
const fileService = require('./FileService');

class PublishController {
  /**
   * publish ipfs
   * @param {*} cid          pubkey
   * @param {*} is_pin       is_pin
   * @param {*} new_path     file key
   * @param {*} res          HTTP response
   * @returns
   */
  static async doPublish(req, res) {
    let cid = req.body.key;
    let ip_address = req.body.ip_address;
    let port = req.body.port || "80";
    let token = req.body.token;
    let peerId = req.body.peerId;
    // let Id = req.body.orderID;
    let Id = req.body.Id;
    let stype = req.body.stype;
    let key = req.body.key;
    let exp = req.body.exp;
    let pin = req.body.pin;
    let isDir = req.body.isDir;

    if (token && token.indexOf('bearer ') > -1) {
      token = token.split('bearer ')[1];
    }

    if (!peerId || !Id || !stype || !exp || !pin || !cid || !key) {
      res.send(BizResult.validateFailed());
      return;
    }
    const header = {
      peerId,
      Id,
      token,
    };
    const request = {
      cid,
      stype,
      exp,
      pin,
      key,
      isDir,
    };
    const putObjectReq = {
      header: header,
      request: request,
    };

    let client = await fileService.getProxGrpcClient(`${ip_address}:${port}`, header);

    console.log('---------------publish', putObjectReq)
    client.Pin(putObjectReq, (err, data) => {
      console.log('---------------publish ------- err', err)
      console.log('---------------publish ------- data', data)
      if (err) {
        res.send({});
        return;
      }
      res.send(BizResult.success(data.cid));
    });
  }

}
module.exports = PublishController;
