const process = require('node:process');
const BigNumber = require('bignumber.js');

module.exports = {
  getDataPath: () => {
    if (process.platform === 'win32') {
      return process.env.USERPROFILE + '\\AppData\\Roaming\\foggie\\';
    } 
    else if (process.platform === 'darwin') {
      return process.env.HOME + '/Library/Application Support/foggie/';
    }
    else {
      return process.env.HOME + '/.config/foggie/';
    }
  },
  walletNameToNumber: (str) => {
    const len = str.length

    let value = new BigNumber(0)

    for (let i = 0; i <= 12; ++i) {
      let c = 0
      if (i < len && i <= 12) {
        c = char_to_symbol(str.charCodeAt(i))
      }

      if (i < 12) {
        c &= 0x1f
        let b_c = new BigNumber(c)
        const two = new BigNumber(2)
        b_c = b_c.times(two.pow(64 - 5 * (i + 1)))
        value = value.plus(b_c)
      } else {
        c &= 0x0f
        value = value.plus(c)
      }
    }

    function char_to_symbol(c) {
      if (c >= 97 && c <= 122) return (c - 97) + 6
      if (c >= 49 && c <= 53) return (c - 49) + 1
      return 0
    }

    return value.toFixed()
  }
}